;COM  <- fr mein TMAKE: COM-Datei erstellen

;---------------------------------------------------------------------;
;                                                                     ;
; Bugfix fr Win95b: HIMEM.SYS belegt ca. 40 KByte statt nur 1 KByte. ;
;                                                                     ;
; Erstellen der COM-Datei:                                            ;
;                                                                     ;
;  tasm himemfix.asm,himemfix.obj,nul,nul                             ;
;  tlink /t himemfix.obj,himemfix.com,nul                             ;
;                                                                     ;
;---------------------------------------------------------------------;

.model tiny
.code

faVolumeID  equ 08h
faDirectory equ 10h

DOS          macro axvalue
              mov   ax,axvalue
              call  DOSCall
             endm

             locals

             org 0100h

             assume cs : @code, ds : @code, es : @code, ss : nothing

DOS2Flag     label byte

COMStart     proc near
              mov   ax,cs
              mov   ds,ax
              mov   es,ax
              cli
              mov   ss,ax
              mov   sp,offset StackTop
              sti
              mov   ah,9
              mov   dx,offset Title$
              int   21h
              mov   ax,3000h
              int   21h
              mov   DOS2Flag,al
              mov   dx,offset BadDOS$
              cmp   ax,0A07h
              jne   error
              jmp   main
Error        label near
              push  dx
              mov   dx,offset Error$
              mov   ah,9
              int   21h
              pop   dx
              mov   ah,9
              int   21h
              mov   dx,offset CRLFCRLF$
              mov   ah,9
              int   21h
              cmp   DOS2Flag,0
              je    @@DOS2
              mov   ax,4CFFh
              int   21h
 @@DOS2:      int   20h
COMStart     endp


DOSCall      proc near
              int   21h
              jnc   @@ret
              cmp   ax,999
              jb    @@0
              mov   ax,999
 @@0:         mov   di,offset IOCode
              cld
              MOV   CL,100
              CALL  @@1
              MOV   CL,10
              CALL  @@1
              call  @@2
              mov   dx,offset IOError$
              jmp   short Error
 @@1:         XOR   AH,AH
              DIV   CL
 @@2:         ADD   AL,'0'
              stosb
              MOV   AL,AH
 @@ret:       RET
DOSCall      endp


FileExist    proc near ; DS:DX = Dateiname
              mov   ax,4300h
              int   21h
              mov   ax,0
              jc    @@ende
              test  cx,faDirectory+faVolumeID
              jnz   @@ende
              inc   ax
 @@ende:      or    ax,ax
              ret
FileExist    endp


CheckSig     proc near
              mov   dx,offset IOSYS
              DOS   3D00h ; open RO
              mov   SysHandle,ax

              mov   bx,ax
              xor   cx,cx
              mov   dx,51F5h
              DOS   4200h ; seek absolute

              mov   bx,SysHandle
              mov   cx,3
              mov   dx,offset CopyBuffer
              DOS   3F00h ; read

              mov   bx,SysHandle
              DOS   3E00h ; close

              cmp   byte ptr CopyBuffer,01h
              jne   @@ende
              cmp   byte ptr CopyBuffer+1,0BCh
              jne   @@ende
              cmp   byte ptr CopyBuffer+2,02h
 @@ende:      ret
CheckSig     endp


Backup       proc near
              mov   dx,offset IOSYS
              DOS   3D00h ; open RO
              mov   SysHandle,ax

              mov   bx,SysHandle
              xor   cx,cx
              xor   dx,dx
              DOS   4202h ; seek relative to end
              mov   IOSizeLow,ax
              mov   IOSizeHigh,dx

              mov   bx,SysHandle
              xor   cx,cx
              xor   dx,dx
              DOS   4200h ; seek absolute

              mov   dx,offset IOSYSBAK
              xor   cx,cx
              DOS   3C00h ; create
              mov   BakHandle,ax

 @@Loop:      mov   bx,SysHandle
              mov   cx,CopyBufferSize
              mov   dx,offset CopyBuffer
              DOS   3F00h ; read

              mov   bx,BakHandle
              mov   cx,ax
              mov   dx,offset CopyBuffer
              DOS   4000h ; write

              sub   IOSizeLow,ax
              sbb   IOSizeHigh,0

              mov   ax,IOSizeLow
              or    ax,IOSizeHigh
              jnz   @@Loop

              mov   bx,SysHandle
              DOS   5700h ; get file time
              mov   bx,BakHandle
              DOS   5701h ; set file time

              mov   bx,SysHandle
              DOS   3E00h ; close

              mov   bx,BakHandle
              DOS   3E00h ; close

              ret
Backup       endp


Patch        proc near
              mov   dx,offset IOSYS
              DOS   4300h ; get file attr
              push  cx

              mov   dx,offset IOSYS
              xor   cx,cx
              DOS   4301h ; set file attr

              mov   dx,offset IOSYS
              DOS   3D02h ; open RW
              mov   SysHandle,ax

              mov   bx,ax
              DOS   5700h ; get file time
              push  cx
              push  dx

              mov   bx,SysHandle
              xor   cx,cx
              mov   dx,51F6h
              DOS   4200h ; seek absolute

              mov   byte ptr CopyBuffer,58h
              mov   bx,SysHandle
              mov   cx,1
              mov   dx,offset CopyBuffer
              DOS   4000h ; write

              pop   dx
              pop   cx
              mov   bx,SysHandle
              DOS   5701h ; set file time

              mov   bx,SysHandle
              DOS   3E00h ; close

              pop   cx
              mov   dx,offset IOSYS
              DOS   4301h ; set file attr

              ret
Patch        endp


main         proc near
              mov   dx,offset Filecheck$
              mov   ah,9
              int   21h

              mov   dx,offset IOSYSBAK
              call  FileExist
              jz    @@NoBak
              mov   dx,offset BakExist$
              jmp   Error

 @@NoBak:     mov   dx,offset IOSYS
              call  FileExist
              jnz   @@SysOK
              mov   dx,offset SysMissing$
              jmp   Error

 @@SysOK:     call  CheckSig
              je    @@SigOK
              mov   dx,offset BadSig$
              jmp   Error

 @@SigOK:     mov   dx,offset Backup$
              mov   ah,9
              int   21h

              call  Backup

              mov   dx,offset Patch$
              mov   ah,9
              int   21h

              call  Patch

              mov   dx,offset Fertig$
              mov   ah,9
              int   21h

              mov   ax,4C00h
              int   21h
main         endp


IOSYS         db    '\IO.SYS',0
IOSYSBAK      db    '\IOSYS.BAK',0
Title$        db    13,10
              db    'HiMem Fix fr Win95b  Version 1.00  (C) 1998 Alexander Foken',13,10
              db    ''
CRLFCRLF$     db    13,10
CRLF$         db    13,10,'$'
Error$        db    'Fehler: $'
BadDOS$       db    'Falsche DOS-Version !$'
BakExist$     db    'Datei \IOSYS.BAK existiert !$'
SysMissing$   db    'Datei \IO.SYS fehlt !$'
IOError$      db    'DOS-Fehler bei Dateibearbeitung: Fehlercode '
IOCode        db    '$$$$'
BadSig$       db    'Falsche Datei \IO.SYS (nicht Win95b) !$'
FileCheck$    db    'Prfe Dateien ...',13,10,'$'
Backup$       db    'Erstelle Sicherheitskopie \IOSYS.BAK ...',13,10,'$'
Patch$        db    'Modifiziere \IO.SYS ...',13,10,'$'
Fertig$       db    'Fertig.',13,10
              db    13,10
              db    'Beim nchsten Start sollte HIMEM.SYS nur noch ca. 1 KByte Speicher belegen.',13,10
              db    'Bei Problemen mit einer Bootdiskette starten, \IO.SYS lschen und \IOSYS.BAK',13,10
              db    'in \IO.SYS umbenennen.',13,10
              db    13,10,'$'

SysHandle     dw    ?
BakHandle     dw    ?
IOSize       label dword
IOSizeLow     dw    ?
IOSizeHigh    dw    ?

             even
StackTop     equ $+1024
CopyBuffer   equ StackTop+2

             org 65520
CopyBufferSize equ $-CopyBuffer

end COMStart
